diff --git a/build/boot/kfreebsd/grub-kfreebsd-pxe.cfg b/build/boot/kfreebsd/grub-kfreebsd-pxe.cfg
index 95897e4..72a601e 100644
--- a/build/boot/kfreebsd/grub-kfreebsd-pxe.cfg
+++ b/build/boot/kfreebsd/grub-kfreebsd-pxe.cfg
@@ -31,13 +31,13 @@ menuentry "" {
 
 menuentry "Default install" {
 	echo "Loading ..."
-	kfreebsd $prefix/kfreebsd.gz
+	kfreebsd $prefix/@KERNEL@
 	kfreebsd_module $prefix/initrd.gz type=mfs_root
 }
 
 menuentry "Automated install" {
 	echo "Loading ..."
-	kfreebsd $prefix/kfreebsd.gz
+	kfreebsd $prefix/@KERNEL@
 	kfreebsd_module $prefix/initrd.gz type=mfs_root
 	set kFreeBSD.auto=true
 	set kFreeBSD.priority=critical
@@ -45,7 +45,7 @@ menuentry "Automated install" {
 
 menuentry "Expert install" {
 	echo "Loading ..."
-	kfreebsd $prefix/kfreebsd.gz
+	kfreebsd $prefix/@KERNEL@
 	kfreebsd_module $prefix/initrd.gz type=mfs_root
 	set kFreeBSD.priority=low
 }
diff --git a/build/config/kfreebsd.cfg b/build/config/kfreebsd.cfg
index c80740b..b8c2d05 100644
--- a/build/config/kfreebsd.cfg
+++ b/build/config/kfreebsd.cfg
@@ -120,8 +120,9 @@ arch_netboot_dir:
 	cp $(TEMP_INITRD) $(TEMP_NETBOOT_DIR)/$(NETBOOT_PATH)
 	cp $(TEMP_KERNEL) $(TEMP_NETBOOT_DIR)/$(NETBOOT_PATH)
 	
-	sed -e "s/@ARCH@/$(ARCH)/g" $(GRUB_CFG_PXE) \
-		> $(TEMP_NETBOOT_DIR)/$(NETBOOT_PATH)/grub.cfg
+	sed -e "s/@ARCH@/$(ARCH)/g" \
+	    -e "s/@KERNEL@/$(notdir $(TEMP_KERNEL))/g" \
+	    $(GRUB_CFG_PXE) > $(TEMP_NETBOOT_DIR)/$(NETBOOT_PATH)/grub.cfg
 	if [ -n "$(GRUB_FONT)" ] ; then \
 		cp $(GRUB_FONT) $(TEMP_NETBOOT_DIR)/$(NETBOOT_PATH)/font.pf2; \
 	fi
